/***************************************************************************
 *   Copyright (C) 2009 by Nicolas Garcia-Pedrajas   *
 *   npedrajas@uco.es   *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _GLOBAL_H
#define _GLOBAL_H
#include <stdio.h>
#include "type.h"
#include "common.h"

extern int gl_dna_index[];

extern FILE *gl_out_file;

extern scalar gl_sensitivity, gl_gamma, gl_c, gl_smote_n, gl_fs_percent_to_keep, gl_fs_min_percent, gl_eta, gl_alpha, gl_htan_a,
       gl_htan_b, gl_flat_spot, gl_gafs_alpha, gl_gafs_mutation, gl_gafs_bit_mutation, gl_gafs_set_probability, gl_gafs_lsmutation,
       gl_brute_force_threshold, gl_sampling_ratio;

extern int gl_seed, TIS_location_in_file, gl_verbose, gl_kernel, gl_k, gl_min_k, gl_max_k, gl_ensemble_t, gl_cv_folds,
       gl_stacking_methods, gl_easy_s_i, gl_smote_k, gl_rfe_subset_size, gl_offset, gl_degree, gl_length, gl_left_window,
       gl_right_window, gl_nn_hidden_nodes, gl_n_epochs, gl_epoch_size, gl_gafs_popsize, gl_gafs_generations;

extern short TRIALS;

extern char gl_datad[], gl_mask_file[];

extern t_RecognitionMethod gl_r_method, gl_base_learner, gl_stacker;

extern t_ImbalanceMethod gl_imbalance_method;

extern t_FSAlgorithm gl_fsalgorithm;

extern bool gl_prune_tree, gl_soften_thresholds, gl_eval_training, gl_knn_weight_by_distance, gl_exit_after_fs, gl_cv_parameters, gl_roc_training,
        gl_write_auc_data, gl_stacking, gl_scale, gl_use_protein_sequence, gl_allow_only_5_letters, gl_use_salzberg_method, gl_reverse_stop_codon,
        gl_do_not_check_sequences;

extern char gl_letters[];

#endif // _GLOBAL_H
// kate: indent-mode cstyle; space-indent on; indent-width 8;
