/***************************************************************************
 *   Copyright (C) 2011 by Nicolas Garcia-Pedrajas                         *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

// Program for checking running PVM task
// If any of the tasks finishes unexpectedly, shut down the PVM system

#include <unistd.h>
#include <pvm3.h>
#include "type.h"
#include "macros.h"

int InitGuardian(int numt, int *tids, char *program, char *gl_out_file)
{
    int guardian;
    char cwd[1000];

    if (pvm_spawn("guardian", NULL, PvmTaskDefault, NULL, 1, &guardian) != 1)
        // if (pvm_spawn ("guardian", NULL, PvmTaskDefault | PvmTaskDebug, NULL, 1, &guardian) != 1)
        OnErrorExit(1, "Guardian not spawned correctly");
    pvm_initsend(PvmDataDefault);
    pvm_pkint(&numt, 1, 1);
    pvm_pkint(tids, numt, 1);
    pvm_pkstr(program);
    pvm_pkstr(gl_out_file);

    if (getcwd(cwd, 1000) != NULL)
        pvm_pkstr(cwd);
    else
        pvm_pkstr("");

    pvm_send(guardian, SENT_BY_MASTER);

    return guardian;
}
