/***************************************************************************
 *   Copyright (C) 2009 by Nicolas Garcia-Pedrajas   *
 *   npedrajas@uco.es   *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "type.h"
#include "common.h"
#include "macros.h"

void LoadGlobalParameters(t_Parameters *parm, char *f_name)
{
    FILE *f;
    char *recognition[] = {"SVM", "kNN", "C45", "STOP", "EasyEnsembleEnsemble", "BalanceCascadeEnsemble", "PWM", "NeuralNet" };
    int n_recognition = 8;

    // Open file
    if ((f = fopen(f_name, "r")) == NULL)
        OnErrorExit(1, "Cannot open parameters file");

    fprintf(parm->out_file, "Parameters (* = default) \n----------\n");

    // [Data]
    LoadString(f, "Data directory", "Research/Experiments/Data/Class", parm->datad, parm->out_file);

    // [Sequence]
    // Sequence is: left window + XXX + right window
    parm->left_window = LoadInteger(f, "Left window", 50, parm->out_file);
    parm->right_window = LoadInteger(f, "Right window", 50, parm->out_file);

    // [General]
    parm->verbose = LoadInteger(f, "Verbose", 0, parm->out_file);
    parm->r_method = LoadEnumerate(f, "Recognition method", recognition, n_recognition, (int) SVM, parm->out_file);

    // [Brute force]
    parm->brute_force_threshold = LoadReal(f, "Brute force threshold", 0.9, parm->out_file);

    // [Feature selection]

    // [Stacking]
    parm->stacking =false;

    // [C4.5]

    // [SVM]

    // [k-NN]

    // [Ensemble]

    // [Smote]

    // [Neural network]

    fclose(f);
}
