/***************************************************************************
 *   Copyright (C) 2010 by Nicolas Garcia-Pedrajas                         *
 *   npedrajas@uco.es                                                      *
 *                                                                         *
 *   This program is FREE software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include <stdio.h>
#include <stdbool.h>
#include "common.h"

// Set next set of parameters for evaluation
// Returns false when no more parameters
bool NextSetOfParameters(int n_parameters, int n_param_values[], int next_param[])
{
    int last = n_parameters - 1;
    bool end = false;

    // From last to first
    while (!end && last >= 0) {
        next_param[last] ++;
        if (next_param[last] > n_param_values[last]) {
            next_param[last] = 1;
            last --;
        } else
            end = true;
    }

    if (last < 0)
        return false;
    else
        return true;
}

void CopyFile(char *dest, char *origin)
{
    FILE *o, *d;
    char ch;

    if ((o = fopen(origin, "r")) == NULL)
        OnErrorExit(1, "Cannot open origin file");

    if ((d = fopen(dest, "w")) == NULL)
        OnErrorExit(1, "Cannot open destination file");

    while ((ch = getc(o)) != EOF)
        putc(ch, d);

    fclose(o);
    fclose(d);
}
